/*****************************************************************************
 * BF70xRSAexample.h
 *****************************************************************************/

#ifndef __BF70XRSAEXAMPLE_H__
#define __BF70XRSAEXAMPLE_H__

#include <sys/platform.h>

/*
 * Define bit length for RSA processing.  The bit length must be an even length.
 */

#define MOD_SIZE_BITS 72
#define MOD_SIZE_BYTES ((MOD_SIZE_BITS+7)/8)
#define MOD_SIZE_WORDS ((MOD_SIZE_BITS+31)/32)
#define MOD_SIZE_WORDS_BY2 ((MOD_SIZE_WORDS+1)/2)

#define RAND_NUM_LEN_BITS 128

typedef struct{
	uint32_t *pub_exp;
	uint32_t *priv_exp;
	uint32_t *n;
	uint32_t *p;
	uint32_t *q;
	uint32_t *phi;
	uint32_t *p_min1;
	uint32_t *q_min1;
	uint32_t *dp;
	uint32_t *dq;
	uint32_t *qinv;
} keypair_t ;

enum decmode{
	pair,
	crt
};

#define DEBUG 1

#ifndef __ADSPSHARC__
#define section(...)
#endif


#endif /* __BF70XRSAEXAMPLE_H__ */
