/*
 * math_utilities.h
 *
 * API to math support functions for RSA example
 */

#ifndef __MATH_UTILITIES_H__
#define __MATH_UTILITIES_H__

#include <stdbool.h>

/* primality test for large number */
bool isPrime(uint32_t *num_buffer, uint32_t szWds);

/* large vector modulo.  specifically when modulo (b) is only 1 word */
uint32_t aModB(uint32_t *a, uint32_t szWds, uint32_t b);

/* calculates the modular inverse */
bool getModInv(uint32_t *num, uint32_t numSzWds, uint32_t *modulo, uint32_t moduloSzWds, uint32_t *modInvRes);

#endif //__MATH_UTILITIES_H__
